package session1.introduction.exercises;

public class Ex5ParisMarathon {

	public static int getMinIndex(int[] times){
		int minTime = Integer.MAX_VALUE;
		int minIndex = 0;
		
		for (int i=0; i< times.length;++i){
			if(times[i] < minTime){
				minTime = times[i];
				minIndex = i;
			}
		}
		return minIndex;
	}
	
	public static int getSecondMinIndex(int[] times, int minIndex){
		int secondMinTime = Integer.MAX_VALUE;
		int secondMinIndex = -1;
		
		for (int i=0; i< times.length;++i){
			if(times[i] < secondMinTime && i != minIndex){
				secondMinTime = times[i];
				secondMinIndex = i;
			}
		}
		return secondMinIndex;
	}
	
	
	public static void main(String[] arguments) {
		int[] times = {245, 268, 157, 180, 235, 170, 152, 130, 151, 290, 193, 210};	
		
		int minIndex = getMinIndex(times);
		int secondMinIndex = getSecondMinIndex(times, minIndex);
		System.out.println("First time is " + times[minIndex] + " and second is " + times[secondMinIndex]);
		
		// alternative solution in one for loop
		int minTime_2 = Integer.MAX_VALUE;
		int secondMinTime_2 = Integer.MAX_VALUE;
		int secondMinIndex_2 = -2;
		int minIndex_2 = -1;
		for (int i=0; i<times.length; ++i){
			if(times[i] < minTime_2){
				secondMinIndex_2 = minIndex_2;
				secondMinTime_2 = minTime_2;
				minIndex_2 = i;
				minTime_2 = times[i];
			}else if (times[i] < secondMinTime_2)
			{
				secondMinIndex_2 = i;
				secondMinTime_2 = times[i];
			}
		}
		System.out.println("First time is " + times[minIndex_2] + " and second is " + times[secondMinIndex_2]);
		
		
		// alternative without keeping indexes	
		int secondbest = Integer.MAX_VALUE;
		int best = Integer.MAX_VALUE;
		
		for (int i = 0; i < times.length; ++i)
			if (times[i] < best)
			{
				secondbest = best;
				best = times[i];
			}else if (times[i] < secondbest)
			{
				secondbest = times[i];
			}
		
		System.out.println("First time is " + best + " and second is " + secondbest);
	}
}
