package session3.collections_inheritance.examples.collections;

import java.util.ArrayList;

public class ArrayListExample {
	public static void main(String[] arguments) { 
		ArrayList<String> someStrings = new ArrayList<String>(); // Array list creation

		// adding as many items as we want
		someStrings.add( "Alice" );
		someStrings.add( "Bob" );
		someStrings.add( "Steve" );
		
		System.out.println( "Size is " + someStrings.size() ); // can get its size 
	
		System.out.println( someStrings.get(0)); // can get items in index position 0 with get
		//System.out.println( someStrings.get(5) ); // error when outside
		
		for (int i = 0; i < someStrings.size(); ++i ) // loop 1
			System.out.println( someStrings.get(i) );	
		
		someStrings.set( 1, "Peter");	// replace content index with new item using set
		//someStrings.set( 5, "Peter 2");	// error when outside
		
		for (String s: someStrings){	// another loop
			System.out.println( s ); // ... that gives us a reference to an object
		}
		
		someStrings.remove(2);
		//someStrings.remove(5); // error when outside
		String first_item = someStrings.get(0); // if we are sure there is something there, test (! isEmpty())
		someStrings.remove(first_item);

		for (String s: someStrings){	// another loop
			System.out.println( s ); // ... that gives us a reference to an object
		}
		
		someStrings.clear();
		if (someStrings.isEmpty()){
			System.out.println("everyone left :(");
		} 
	}

}
