package session3.collections_inheritance.exercises.Ex2Ex4inheritanceRPG;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class RPG {

	public static void main (String[] args){
		
		Person p1 = new Person ("John", 100);
		p1.sayName();
		
		Wizard w1 = new Wizard("Zed", 100, 'm', 100);
		w1.sayName();
		
		Thief t1 = new Thief("The Fox", 150);
		t1.sayName();
		
		Fighter f1 = new Fighter("Hulk", 300);
		f1.sayName();
		
		p1.attackPerson(w1);
		t1.attackPerson(p1);
		w1.attackPerson(f1);
		f1.attackPerson(t1);
		
		
		// attacking spree
		List<Person> characters = new ArrayList<Person>(); // a way to implement the interface list
		Collections.addAll(characters, p1,w1,f1,t1); 	// Collections is a class that implements functions for collections
		System.out.println( "\n------- New Attack Round ------"); // \n is the newline character
		int index = 0;
		while ( characters.size() > 1){
			int attacker_index = index % ( characters.size());	// index % size, ensures return to 0 when reach the end
			int victim_index = (index+1)% ( characters.size()); // same for index+1
			characters.get(attacker_index).attackPerson(characters.get(victim_index));
			++index;
			
			if (characters.get(victim_index).getHealth() <= 0) {
				System.out.println( "!!! "+ characters.get(victim_index).getName() + " eliminated");
				characters.remove(victim_index);
			}
		}
		if(characters.size() == 1)
			System.out.println("The winner is " + characters.get(0).getName());
	}
}
