package session3.collections_inheritance.exercises.Ex5interfaceRPG;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import session3.collections_inheritance.exercises.Ex5interfaceRPG.characters.ElfWizardThief;
import session3.collections_inheritance.exercises.Ex5interfaceRPG.characters.OrcFighter;

public class interfaceRPG {

	public static void main (String[] args){
		
		Person p1 = new Person ("John", 100, 'm');
		p1.sayName();
		
		Person ewt = new ElfWizardThief("Zed", 100, 'm', 100);
		ewt.sayName();

		Person ewtf = new ElfWizardThief("Morgana", 100, 'f', 150);
		ewtf.sayName();

		Person ocf = new OrcFighter("Hulk", 300, 'm');
		ocf.sayName();
		
		Person ocff = new OrcFighter("Elsa", 300, 'f');
		ocff.sayName();
		
		
		// attacking spree
		List<Person> characters = new ArrayList<Person>(); // a way to implement the interface list
		Collections.addAll(characters, p1,ewt,ewtf,ocf,ocff); 	// Collections is a class that implements functions for collections
		System.out.println( "\n------- New Attack Round ------"); // \n is the newline character
		int index = 0;
		while ( characters.size() > 1){
			int attacker_index = index % ( characters.size());	// index % size, ensures return to 0 when reach the end
			int victim_index = (index+1)% ( characters.size()); // same for index+1
			characters.get(attacker_index).specialAttackPerson(characters.get(victim_index));
			++index;
			
			if (characters.get(victim_index).getHealth() <= 0) {
				System.out.println( "!!! "+ characters.get(victim_index).getName() + " eliminated");
				characters.remove(victim_index);
			}
		}
		if(characters.size() == 1)
			System.out.println("The winner is " + characters.get(0).getName());
	}
}
