package session5.ioExamples;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class SimpleTypeInput {
	static public void main (String[] args){
		
		InputStreamReader stream = 
				new InputStreamReader(System.in);			
		BufferedReader keyboardInput = 
				new BufferedReader (stream);
		
		int ints_i_have_read = 0;
		System.out.print("Please type several integers, use \",\" to separate them: ");
		
		try {
			String answer = keyboardInput.readLine();
			String[] all_strings = answer.split(",");
			int[] all_ints = new int[all_strings.length]; 
			
			for (int i = 0; i < all_ints.length; ++i, ++ints_i_have_read){
				all_ints[i] = Integer.parseInt( all_strings[i] );
			}

			for (int i = 0; i < all_ints.length; ++i){
				System.out.print(all_ints[i] + " ");
			}
			
			}catch(java.lang.NumberFormatException e){
				System.out.print("Your input at pos " +  ++ints_i_have_read +" is not an integer!");
			}catch (IOException e) {
			e.printStackTrace();
		}
		


		
	}
}
