package session1.introduction.exercises;

public class Ex2Pay {

	public static void printPay(int hours, double basePay){
		
		int overtime = 40;
		int maxWork = 60;
		double minimumWage = 9.61;
		double overtimeRate = 1.5;
		
		double pay = 0.0;
		
		if (basePay < minimumWage){
			System.out.println("You must be payed at least " + minimumWage + " euros per hour");
		} else if (hours > 60){
			System.out.println("You cannot work more than " + maxWork + " hours" );
		}else{
			int hoursOvertime = 0;
			int hoursNormal = hours;
			if (hours > overtime){
				hoursOvertime = hours - overtime; 
				hoursNormal = hours - hoursOvertime;
			}
			pay = hoursNormal*minimumWage + hoursOvertime*minimumWage*overtimeRate;
			System.out.println("Payment is " + pay + " with " + hoursOvertime + " hours of overtime");
		}
	}

	public static void main(String[] arguments) {
		printPay(30, 4.0);
		printPay(30, 10.0);
		printPay(42, 12.0);
		printPay(70, 11);
	}
}
