package session2.oop.examples;

public class Car {

	static int noOfCarsMade = 0;
	
	String make;
	String color;
	int horsepower;
	double mpg;
	boolean manual;
	int kilometers = 0;
	Car[] overtaken;

	Car (){
		this("nomake", "nocolor");
	}
	
	Car ( String mymake, String mycolor){
		make = mymake;
		color = mycolor;
	}
	
	void move (int speed, int time) {
		kilometers += speed*time;
		System.out.println("Covered " + kilometers + "km");
	}

	void move (int kilometers) {
		kilometers += kilometers;
		System.out.println("Covered " + kilometers + "km");
	}

	
	void printCar(){
		System.out.println("make:" + make + ", color:" + color + ", km:" + kilometers);
	}
	
	public static void main (String[] args){
		Car myCar = new Car ("peugeot", "pink");
		myCar.move(30, 2);
		myCar.printCar();
		
		myCar.move(20);
		myCar.printCar();
		
		Car unknownCar = new Car ();
		unknownCar.printCar();

	}
}


