package session2.oop.exercises.library_version2;

public class Book {
	private String _title;
	private String _author;
	private int _num_of_copies;
	private int _max_copies;
	
	private static int all_books = 0;
	
	Book (String t, String a, int n){
		_title = t;
		_author = a;
		
		if (n < 0 )
			n = 0;
		_num_of_copies = n;
		_max_copies = n;
		
		++all_books;
	} 
	
	public void borrowBook(){
		if 	(_num_of_copies <= 0 )
			System.out.println("No copies left!");
		else{
			--_num_of_copies;
			System.out.println("Borrowed "+ _title);			
			}
	}
	
	public void returnBook(){
		if 	(_num_of_copies > _max_copies )
				System.out.println("Too many copies!");
			else{
				++_num_of_copies;
				System.out.println("Returned "+ _title);			
				}
	}
	
	public void printBook(){
		System.out.println("Book "+ _title + " "+ _author + " " + _num_of_copies + " "+ all_books );

	}
}
