package session3.collections_inheritance.examples.collections.arraylist_restaurant;

import java.util.ArrayList;

public class ArrayListMenu {
		private ArrayList<Dish> _dishes = new ArrayList<Dish>(); // full menu
		
		private ArrayList<Dish> _order = new ArrayList<Dish>(); // order
		
		public void addDish(Dish dish){
			_dishes.add(dish);
			System.out.println("Menu item " + dish.getName() + " added");

		}
		
		public void setOrder(String... dishes){
			
			int dishes_found = 0;
			int calories = 0;
			double price = 0.0;
			
			for (int i = 0; i < dishes.length;++i)
				for (Dish d: _dishes){
					if ( dishes[i].equals(d.getName()) ){
						++dishes_found;
						_order.add(d);
						calories += d.getCalories();
						price += d.getPrice();
					}
				}
			
			System.out.println("Found " + dishes_found + " out of the " + dishes.length +  " ordered dishes");
			System.out.println("Meal costs " + getPrice() + "euros and has " + getCalories() + " calories");

		}
								
		private double getPrice(){
			double price = 0.0;
			for (Dish d: _order){
				price += d.getPrice();
			}	
			return price;
		}

		private int getCalories(){
			int calories = 0;
			for (Dish d: _order){
				calories += d.getCalories();
			}	
			return calories;
		}
		
		public void reverseMenu(){
			ArrayList<Dish> tmp = new ArrayList<Dish>();
			
			for (int d=_dishes.size()-1; d >= 0; --d){
				tmp.add( _dishes.get(d) );
			}
			_dishes = tmp;
		}
		
		public void printMenu(){
			
			System.out.println("----------");

			int i = 0;
			for (Dish d: _dishes){
				System.out.println("Menu item "+ i + " : " + d.getName());
				++i;
			}				
		}
}
