package session3.collections_inheritance.examples.collections.arraylist_restaurant;

public class Dish {
	static int numberOfDishes = 0; // if I wanted a unique id for the dishes
	
	private String _name;
	private double _price;
	private int _calories;
	private final int _dishId;
	
	public Dish(String name, double price, int calories){
		_name = name;
		_price = price;
		_calories = calories;
		
		_dishId = numberOfDishes;
		++numberOfDishes;
	}
	
	public double getPrice() {return _price;}
	public int getCalories() {return _calories;}
	public String getName(){return _name;}
	public int getID() {return _dishId;}
	
	public void order(){
		System.out.println(_name + "(" + _price + "euros, "+ _calories + "Kcal) ordered ");
	}
}
