package session3.collections_inheritance.exercises.Ex1arraylist_library;

import java.util.ArrayList;

public class Library {

	static ArrayList<Book> books = new ArrayList<Book>(); // Array list creation

	
	public static void main(String[] args) {
		// populating library
		books.add(new Book("Alice in Wonderland", "Lewis Carroll",3));
		books.add(new Book("The Wind in the Willows", "Kenneth Grahame",1));
		books.add(new Book("Treasure Island", "Robert Louis Stevenson",2));
		books.add(new Book("Harry Potter", "J. K. Rowling",4));
		books.add(new Book("War of the Worlds", "H.G. Wells",1));
	
		// try to borrow two copies of a book and then return one
		for (Book book_i : books){
			System.out.println("Trying to borrow 2 copies of: "+ book_i.getTitle());
			book_i.borrowBook();
			book_i.borrowBook();
		}
		
		for (Book book_i : books){
			System.out.println("Trying to return 1 copy of: "+ book_i.getTitle());
			book_i.returnBook();
		}

		// or can make a list of requests
		Book[] requests = new Book[12];
		requests[0] = requests[1] = requests[2] = books.get(0);
		requests[3] = requests[4] = requests[5] = books.get(1);
		requests[6] = requests[7] = requests[8] = books.get(2);
		requests[9] = requests[10] = requests[11] = books.get(3);

		System.out.println("----");
		for (int req_i = 0; req_i < requests.length; ++req_i){
			System.out.println("Trying to borrow a copy of: "+ requests[req_i].getTitle());
			requests[req_i].borrowBook();
		}
	}

}
