package session3.collections_inheritance.exercises.Ex3InterfaceQueue;

public class ArrayQueue implements Queue {

	String[] container = new String[5]; 
	int size_counter = 0;
	int start_index = 0;
	
	
	@Override
	public void add(String s) {
		if (size_counter < container.length -1 ){ // still space
			++size_counter;	
			
			container[size_counter] = s;
		}else{
			int doubling = 2*container.length;
			
			String[] new_container = new String[doubling]; 
			for (int i = 0; i< container.length -1; ++i)
				new_container[i] = container[i];
			
			container = new_container;
		}
		System.out.println("adding " + s);
	}

	@Override
	public String remove() {
		if (isEmpty ()){
			return null;
		}
		
		String first_element = container[0];
		String[] slide_left = new String[container.length]; 
		for (int i = 1; i< container.length-1; ++i)
			slide_left[i-1] = container[i];
	
		--size_counter;
		container = slide_left;
		System.out.println("removing " + first_element);	
		return "first_element";
	}

	@Override
	public boolean isEmpty() {
		if (size_counter == 0){
			return true;
		}
		return false;
	}

	@Override
	public void print() {
		for(int i = 0; i< container.length; ++i){
			System.out.print( container[i] + " ");
		}
		
	}

}
