package session3.collections_inheritance.exercises.Ex5interfaceRPG;

public class Person {
	protected String _name;
	protected int _max_health, _health;
	protected int _mana = 0;
	protected char _sex;
	protected int _attack = 10;
	
	public Person(String n, int h, char s, int m){
		_name = n;
		_health = h;
		_sex = s;
		_mana = m;
	}
	
	public Person(String n, int h, char s){
		this(n,h,s,0);
	}
	
	public void sayName(){
		System.out.println(_name);
	}
		
	public void giveStats(){
		System.out.println("<<"+ _name + ">> health:" + _health + ", mana:" + _mana);
	}
	
	public void attackPerson(Person target){
		System.out.println( getName() + " attacking ..." + target.getName());
		target.reduceHealth(_attack);
	}
	
	public void specialAttackPerson (Person target){
		attackPerson(target);
	}
	
	public String getName(){
		return _name;
	}
	
	public void reduceHealth(int damage){
		System.out.println("   " + getName() + " health " + _health + "->"+ (_health-damage));

		_health -= damage;
		
		if (_health < 0){
//			_health = _max_health;
//			System.out.println("Almost eliminated! Drinking healing potion ...");
		}
	}
	
	public int getHealth(){
		return _health;
	}
}



