package session3.collections_inheritance.exercises.Ex5interfaceRPG.characters;

import session3.collections_inheritance.exercises.Ex5interfaceRPG.Person;
import session3.collections_inheritance.exercises.Ex5interfaceRPG.professions.Thief;
import session3.collections_inheritance.exercises.Ex5interfaceRPG.professions.Wizard;
import session3.collections_inheritance.exercises.Ex5interfaceRPG.races.Elf;

public class ElfWizardThief extends Elf implements Wizard, Thief{

	int _max_mana;
	
	public ElfWizardThief(String n, int h, char s, int m) {
		super(n, h, s, m);
		_max_mana = m;
	}

	@Override
	public void sneakAttackPerson(Person target) {		
		System.out.println( getName() + " sneak attacking ..." + target.getName());
		target.reduceHealth(5);
		_health += 5;
	}

	@Override
	public void magicAttackPerson(Person target) {
		System.out.println( getName() + " magic attacking ..." + target.getName());
		target.reduceHealth(20);
		_mana -= 10;
		
		if (_mana < 0 ){
			_mana = _max_mana;
			System.out.println("Almost ran out of mana! Drinking mana potion ...");
		}
	}
	
	public void specialAttackPerson(Person target){
		super.attackPerson(target);
		magicAttackPerson(target);
		sneakAttackPerson(target);
	}

}
