package session3.collections_inheritance.exercises.Ex5interfaceRPG.characters;

import session3.collections_inheritance.exercises.Ex5interfaceRPG.Person;
import session3.collections_inheritance.exercises.Ex5interfaceRPG.professions.Fighter;
import session3.collections_inheritance.exercises.Ex5interfaceRPG.races.Orc;

public class OrcFighter extends Orc implements Fighter 
{

	public OrcFighter(String n, int h, char s) {
		super(n, h, s);
		_health += 20;
		_mana -= 20;
	}

	@Override
	public void powerAttackPerson(Person target) {
		System.out.println( getName() + " power attacking ..." + target.getName());
		target.reduceHealth(15);
	}

	public void specialAttackPerson(Person target){
		super.specialAttackPerson(target);
		powerAttackPerson(target);
	}
}
